summaryrefslogtreecommitdiffstats
path: root/testing/source/samba/samba.SlackBuild
diff options
context:
space:
mode:
author Patrick J Volkerding <volkerdi@slackware.com>2023-02-03 20:04:33 +0000
committer Eric Hameleers <alien@slackware.com>2023-02-03 21:35:10 +0100
commit201ae578a4cd9577f795e2d25dd65ec8533c51d3 (patch)
tree31b568866deffda8bd039d397044c8ccd6324f2a /testing/source/samba/samba.SlackBuild
parent9de77f5e56e5de8a14904474ed645f2bdd6ed5bf (diff)
downloadcurrent-201ae578a4cd9577f795e2d25dd65ec8533c51d3.tar.gz
current-201ae578a4cd9577f795e2d25dd65ec8533c51d3.tar.xz
Fri Feb 3 20:04:33 UTC 202320230203200433
a/aaa_glibc-solibs-2.37-x86_64-2.txz: Rebuilt. a/e2fsprogs-1.46.6-x86_64-1.txz: Upgraded. a/hwdata-0.367-noarch-1.txz: Upgraded. l/glibc-2.37-x86_64-2.txz: Rebuilt. [PATCH] Account for grouping in printf width (bug 23432). This issue could cause a overflow with sprintf in the corner case where an application computes the size of buffer to be exactly enough to fit the digits in question, but sprintf ends up writing a couple of extra bytes. Thanks to marav for the heads-up. For more information, see: https://www.cve.org/CVERecord?id=CVE-2023-25139 (* Security fix *) l/glibc-i18n-2.37-x86_64-2.txz: Rebuilt. l/glibc-profile-2.37-x86_64-2.txz: Rebuilt. l/libcap-2.67-x86_64-1.txz: Upgraded. l/poppler-data-0.4.12-noarch-1.txz: Upgraded. extra/php81/php81-8.1.15-x86_64-1.txz: Upgraded. testing/packages/samba-4.17.5-x86_64-2.txz: Rebuilt. Build with the bundled Heimdal instead of the system MIT Kerberos, since MIT Kerberos has more issues when Samba is used as an AD DC. I'd appreciate any feedback on the "Samba on Slackware 15" thread on LQ about how well this works. Although it's not the sort of change I'd normally make in a -stable release such as Slackware 15.0, in this case I'm considering it if it can be done painlessly for any existing users... but I'll need to see some reports about this. I'd like to note that yes, of course we saw the "experimental" label in the configure flag we used to build Samba, but we also saw another prominent Linux distribution go ahead and use it anyway. :) And the Samba package built against MIT Kerberos cooked in the previous -current development cycle for a couple of years without any objections. Anyway, hopefully we'll get some testing from folks out there with networks that use AD and go from there. Thanks to Rowland Penny of the Samba team for clarifying this situation.
Diffstat (limited to 'testing/source/samba/samba.SlackBuild')
-rwxr-xr-xtesting/source/samba/samba.SlackBuild257
1 files changed, 257 insertions, 0 deletions
diff --git a/testing/source/samba/samba.SlackBuild b/testing/source/samba/samba.SlackBuild
new file mode 100755
index 000000000..099c1079f
--- /dev/null
+++ b/testing/source/samba/samba.SlackBuild
@@ -0,0 +1,257 @@
+#!/bin/bash
+
+# Copyright 2008, 2009, 2010, 2012, 2013, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022, 2023 Patrick J. Volkerding, Sebeka, Minnesota, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Modified 2012 by Eric Hameleers <alien at slackware.com> for ARM port.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PKGNAM=samba
+VERSION=${VERSION:-$(echo samba-*.tar.?z | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
+BUILD=${BUILD:-2}
+
+# This option may be set to "heimdal" or "mit".
+# Upstream considers the use of MIT Kerberos for provisioning an AD DC
+# to be experimental (for now), and recommends using the bundled Heimdal.
+KERBEROS=${KERBEROS:-heimdal}
+
+if [ "$KERBEROS" = "mit" ]; then
+ KERB_OPTIONS="--with-system-mitkrb5 --with-experimental-mit-ad-dc"
+elif [ "$KERBEROS" = "heimdal" ]; then
+ # Please note that this perl module will be required: https://metacpan.org/pod/JSON
+ KERB_OPTIONS="--bundled-libraries=heimdal"
+fi
+
+if [ -e $CWD/machine.conf ]; then
+ . $CWD/machine.conf ]
+elif [ -e /etc/slackbuild/machine.conf ]; then
+ . /etc/slackbuild/machine.conf ]
+else
+ # Automatically determine the architecture we're building on:
+ if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i586 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
+ fi
+ # Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+ if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+ elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+ elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+ else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+ fi
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
+ exit 0
+fi
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
+
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-samba
+rm -rf $PKG
+mkdir -p $TMP $PKG
+
+cd $TMP
+rm -rf samba-$VERSION
+tar xvf $CWD/samba-$VERSION.tar.?z || exit 1
+cd samba-$VERSION || exit 1
+
+# Add time.h to libsmbclient.h for ffmpeg compatibility:
+zcat $CWD/samba.libsmbclient.h.ffmpeg.compat.diff.gz | patch -p1 --verbose || exit 1
+
+if [ ! -d source3/lib/cmdline ]; then
+ ( cd source3/lib
+ mkdir cmdline
+ cd cmdline
+ ln -sf ../../../source3/include/popt_common.h . )
+fi
+
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \+ -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \+
+
+# Choose correct options depending on whether PAM is installed:
+if [ -L /lib${LIBDIRSUFFIX}/libpam.so.? ]; then
+ PAM_OPTIONS="--with-pam --with-pammodulesdir=/lib${LIBDIRSUFFIX}/security"
+ unset SHADOW_OPTIONS
+else
+ unset PAM_OPTIONS
+ SHADOW_OPTIONS="--without-pam"
+fi
+
+# Some of these options could be auto-detected, but declaring them
+# here doesn't hurt and helps document what features we're trying to
+# build in.
+#
+# LDFLAGS are needed to avoid problems with missing symbols.
+LDFLAGS="-Wl,--no-as-needed" \
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --enable-fhs \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --includedir=/usr/include \
+ --bindir=/usr/bin \
+ --sbindir=/usr/sbin \
+ --mandir=/usr/man \
+ --sysconfdir=/etc \
+ --with-configdir=/etc/samba \
+ --with-piddir=/var/run \
+ --with-privatedir=/var/lib/samba/private \
+ --with-privatelibdir=/usr/lib${LIBDIRSUFFIX} \
+ --with-modulesdir=/usr/lib${LIBDIRSUFFIX} \
+ --with-lockdir=/var/cache/samba \
+ --with-logfilebase=/var/log/samba \
+ --localstatedir=/var \
+ --enable-cups \
+ --with-acl-support \
+ --with-automount \
+ --with-quotas \
+ --with-syslog \
+ --with-utmp \
+ --with-winbind \
+ --with-ldap \
+ --with-ads \
+ --without-fam \
+ $KERB_OPTIONS \
+ $PAM_OPTIONS \
+ $SHADOW_OPTIONS \
+ --build=$TARGET || exit 1
+ # Gives errors:
+ #--builtin-libraries=replace,ccan \
+
+# Build with waf directly so that multiple jobs work.
+# Script lifted from "./configure".
+PREVPATH=$(dirname $0)
+WAF=./buildtools/bin/waf
+# using JOBS=1 gives maximum compatibility with
+# systems like AIX which have broken threading in python
+JOBS=$(echo $NUMJOBS | tr -dc '0-9')
+export JOBS
+# Make sure we don't have any library preloaded.
+unset LD_PRELOAD
+# Make sure we get stable hashes
+PYTHONHASHSEED=1
+export PYTHONHASHSEED
+cd . || exit 1
+${PYTHON:=python3} $WAF build "$@" || exit 1
+cd $PREVPATH
+
+mkdir -p \
+ $PKG/usr/doc/samba-$VERSION \
+ $PKG/var/spool/samba \
+ $PKG/var/log/samba \
+ $PKG/var/lib/samba/private \
+ $PKG/var/cache/samba
+chmod 700 $PKG/var/lib/samba/private
+chmod 1777 $PKG/var/spool/samba
+
+# Again, use waf directly to allow multithreading:
+#make install DESTDIR=$PKG || exit 1
+DESTDIR=$PKG
+export DESTDIR
+${PYTHON:=python3} $WAF install "$@" || exit 1
+
+# Install the smbprint script:
+install -m0744 packaging/printing/smbprint $PKG/usr/bin/smbprint
+
+# Add a sample config file:
+cat $CWD/smb.conf.default > $PKG/etc/samba/smb.conf-sample
+
+# Setup a default lmhosts file:
+echo "127.0.0.1 localhost" > $PKG/etc/samba/lmhosts.new
+
+if [ ! -r $PKG/usr/bin/smbget ]; then
+ rm -f $PKG/usr/share/man/man1/smbget.1
+fi
+
+# We'll add rc.samba to the init directory, but chmod 644 so that it doesn't
+# start by default:
+mkdir -p $PKG/etc/rc.d
+cat $CWD/rc.samba > $PKG/etc/rc.d/rc.samba.new
+chmod 644 $PKG/etc/rc.d/rc.samba.new
+
+mv $PKG/usr/share/man $PKG/usr
+gzip -9 $PKG/usr/man/man?/*.?
+
+find $PKG | xargs file | grep -e "executable" -e "shared object" \
+ | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+
+# PAM related stuff we don't use:
+rm -r $PKG/usr/share/locale
+rm -f $PKG/usr/man/man8/pam*
+
+cp -a \
+ COPYING* MAINTAINERS Manifest PFIF.txt README* \
+ Read-Manifest-Now Roadmap WHATSNEW.txt docs examples \
+ $PKG/usr/doc/samba-$VERSION
+# These are installed elsewhere:
+rm -rf $PKG/usr/doc/samba-$VERSION/docs/htmldocs \
+ $PKG/usr/doc/samba-$VERSION/docs/manpages
+# Empty now?
+rmdir $PKG/usr/doc/samba-$VERSION/docs 2> /dev/null
+# I'm sorry, but when all this info is included in HTML, adding 7MB worth of
+# PDF files just to have extra artwork is more fluff than I'll agree to.
+rm -f $PKG/usr/doc/samba-$VERSION/docs/*.pdf
+# Also redundant also:
+rm -rf $PKG/usr/doc/samba-$VERSION/docs/docbook
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+zcat $CWD/doinst.sh.gz > $PKG/install/doinst.sh
+
+cat << EOF
+
+*** Be sure the package contains:
+
+drwxr-xr-x 2 root root 4096 May 3 15:46 /var/cache/samba/
+drwx------ 2 root root 1024 Mar 12 13:21 /var/lib/samba/private
+drwxr-xr-x 2 root root 48 Aug 29 13:06 /var/log/samba/
+drwxrwxrwt 2 root root 1024 Mar 12 13:21 /var/spool/samba/
+
+EOF
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/samba-$VERSION-$ARCH-$BUILD.txz